function vexalarm_buildFrames()
	for key,val in pairs(vexalarm.frames) do
		val:Hide()
		vexalarm.frames[key] = nil
	end
	
	for key in pairs(vexalarm_f_data) do
		vexalarm.frames[key] = CreateFrame("Frame", nil, UIparent)
		vexalarm_set_frame(key)
		
		vexalarm.last_spell_id[key] = ""
		vexalarm.last_spell_timestamp[key] = 0
		vexalarm.last_spell_event[key] = ""
		vexalarm.last_spell_caster[key] = ""
		
		vexalarm.proclaims[key] = {}
		vexalarm.proclaimPlaces[key] = {}
		
		vexalarm.totemsPlaced[key] = {}
	end
end

function vexalarm_set_frame(frame)
	vexalarm.frames[frame]:SetWidth(vexalarm_f_data[frame]["design"]["size"]["width"])
	vexalarm.frames[frame]:SetHeight(vexalarm_f_data[frame]["design"]["size"]["height"])
	
	vexalarm.frames[frame]:SetFrameStrata("LOW")
	vexalarm.frames[frame]:SetPoint(
		vexalarm_f_data[frame]["design"]["position"]["bg"]["frameanchor"],
		UIParent,
		vexalarm_f_data[frame]["design"]["position"]["bg"]["anchor"],
		vexalarm_f_data[frame]["design"]["position"]["bg"]["x"],
		vexalarm_f_data[frame]["design"]["position"]["bg"]["y"])
		
	vexalarm.frames[frame]:SetBackdrop({
		bgFile=vexalarm.LSM:Fetch("background", vexalarm_f_data[frame]["design"]["bg"]["texture"]),
		edgeFile=vexalarm.LSM:Fetch("border", vexalarm_f_data[frame]["design"]["border"]["texture"]),
		tile=false,
		edgeSize=vexalarm_f_data[frame]["design"]["border"]["size"]})
		
	vexalarm.frames[frame]:SetBackdropColor(
		vexalarm_f_data[frame]["design"]["bg"]["color"]["r"],
		vexalarm_f_data[frame]["design"]["bg"]["color"]["g"],
		vexalarm_f_data[frame]["design"]["bg"]["color"]["b"],
		vexalarm_f_data[frame]["design"]["bg"]["color"]["a"])
		
	vexalarm.frames[frame]:SetBackdropBorderColor(
		vexalarm_f_data[frame]["design"]["border"]["color"]["r"],
		vexalarm_f_data[frame]["design"]["border"]["color"]["g"],
		vexalarm_f_data[frame]["design"]["border"]["color"]["b"],
		vexalarm_f_data[frame]["design"]["border"]["color"]["a"])
end