function vexalarm_spellcheck(auraID, player, eventchar, frame)
	local returnvalue = ""
	
	local auraID=tostring(auraID)

	--overflow check - check data
	local currenttime = time()
	local eventstring = ""
	if eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_RESURRECT" then eventstring = "gain"
	else eventstring = "lost" end
		
	if vexalarm_spells_defaults[auraID] ~=nil then
		local spellaccept = false
		if frame == "rw" then
			if vexalarm_data["rw"]["spelldata"]["useprofile"] then
				local rw_sp = vexalarm_data["rw"]["spelldata"]["spellprofile"]
				if vexalarm_sp[rw_sp] ~= nil then
					spelldata = vexalarm_sp[rw_sp]
					if spelldata[auraID] ~= nil then
						spellaccept = spelldata[auraID][vexalarm_getplayerrole(player)]
					end
				end
			else
				spellaccept = vexalarm_s[auraID][vexalarm_getplayerrole(player)]
			end
		else
			if vexalarm_f_data[frame]["spelldata"]["useprofile"] then
				local rw_sp = vexalarm_f_data[frame]["spelldata"]["spellprofile"]
				if vexalarm_sp[rw_sp] ~= nil then
					spelldata = vexalarm_sp[rw_sp]
					if spelldata[auraID] ~= nil then
						spellaccept = spelldata[auraID][vexalarm_getplayerrole(player)]
					end
				end
			else
				spellaccept = vexalarm_s[auraID][vexalarm_getplayerrole(player)]
			end
		end
		
		local totem = false
		if vexalarm_spells_defaults[auraID][7] ~= nil then
			totem = true
		end
		local temp = vexalarm_spells_defaults[auraID][6]
		local eventaccept = false
		if ((eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_AURA_REMOVED" or (eventchar == "SPELL_SUMMON" and totem)) and (temp == "selfbuff" or temp == "buff" or temp == "grpbuff")) or
			((eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT") and (temp == "instant" or temp == "instantself"))	then
				eventaccept = true
		end
		
		if spellaccept and eventaccept then
			returnvalue = temp
		end
	
		if frame == "rw" then
			if auraID==vexalarm.last_spell_id_RW and vexalarm.last_spell_timestamp_RW+1>=currenttime and eventstring == vexalarm.last_spell_event_RW then
				if returnvalue == "grpcheck" then
					returnvalue = "dejavue"
				else
					if player==vexalarm.last_spell_caster_RW then
						returnvalue = "dejavue"
					end
				end
			end
		else
			if auraID==vexalarm.last_spell_id[frame] and vexalarm.last_spell_timestamp[frame]+1 >= currenttime and vexalarm.last_spell_event[frame] == eventstring then
				if returnvalue == "grpcheck" then
					returnvalue = "dejavue"
				else
					if vexalarm.last_spell_caster[frame] == player then
						returnvalue = "dejavue"
					end
				end
			end
		end
		
		--overflow check - update data
		if returnvalue ~= "" and returnvalue ~= "dejavue" then
			if frame == "rw" then
				vexalarm.last_spell_id_RW = auraID
				vexalarm.last_spell_timestamp_RW = currenttime
				vexalarm.last_spell_event_RW = eventstring
				vexalarm.last_spell_caster_RW = player
			else
				vexalarm.last_spell_id[frame] = auraID
				vexalarm.last_spell_timestamp[frame] = currenttime
				vexalarm.last_spell_event[frame] = eventstring
				vexalarm.last_spell_caster[frame] = player
			end
		end
	end
		
	return returnvalue
end

function vexalarm_check_fulltext(frame)
	local currenttime = time()
	
	-- check and remove old proclaims
	local removes = 0
	if #vexalarm.proclaims[frame] ~= 0 then
		for i=1, #vexalarm.proclaims[frame] do
			local k=i-removes
			if vexalarm.proclaims[frame][k][1]+vexalarm_f_data[frame]["timedata"]["show"]+vexalarm_f_data[frame]["timedata"]["vanish"]+0.2 <= currenttime then
				vexalarm.proclaims[frame][k][2][1]:Hide()
				local place = vexalarm.proclaims[frame][k][3]
				vexalarm.proclaimPlaces[frame][place] = false
				table.remove(vexalarm.proclaims[frame], k)
				removes = removes + 1
			end
		end
	end

	-- sort current proclaims
	if vexalarm_f_data[frame]["design"]["allowscrolling"] and #vexalarm.proclaims[frame] ~= 0 then
		for i=1, #vexalarm.proclaims[frame] do
			vexalarm.proclaimPlaces[frame][vexalarm.proclaims[frame][i][3]] = false
			vexalarm.proclaimPlaces[frame][i]=true
			vexalarm.proclaims[frame][i][3] = i
			if vexalarm_f_data[frame]["design"]["scrolldown"] then
				vexalarm.proclaims[frame][i][2][2]:SetPoint("BOTTOMLEFT", vexalarm.frames[frame], "BOTTOMLEFT",
											vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"],
											(vexalarm_f_data[frame]["design"]["position"]["alarm"]["spacing"]*i)-vexalarm_f_data[frame]["design"]["position"]["alarm"]["y"])

			else
				vexalarm.proclaims[frame][i][2][2]:SetPoint("TOPLEFT", vexalarm.frames[frame], "TOPLEFT",
											vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"],
											(-vexalarm_f_data[frame]["design"]["position"]["alarm"]["spacing"]*i)+vexalarm_f_data[frame]["design"]["position"]["alarm"]["y"])
			end
		end
	end
end

function vexalarm_generate_fulltext(alarmtype, spell, spellid, caster, target, status, msg, frame)
	local statusstring = ""
	if status then
		statusstring = "active"
	else
		statusstring = "inactive"
	end
	
	local newframe = CreateFrame("Frame", nil, vexalarm.frames[frame])
	newframe:Show()
	local fontstring = newframe:CreateFontString("frame", "ARTWORK", "GameFontNormal")
	
	--remove oldest proclaims when too many proclaims
	if #vexalarm.proclaims[frame] >= vexalarm_f_data[frame]["design"]["maxevents"] then
		vexalarm.proclaims[frame][1][2][1]:Hide()
		vexalarm.proclaimPlaces[frame][vexalarm.proclaims[frame][1][3]] = false
		table.remove(vexalarm.proclaims[frame], 1)
	end
	local position = 0
	for i=1, #vexalarm.proclaimPlaces[frame]+1 do
		if not(vexalarm.proclaimPlaces[frame][i]) and position == 0 then position = i end
	end
	vexalarm.proclaimPlaces[frame][position] = true
	
	if vexalarm_f_data[frame]["design"]["scrolldown"] then
		fontstring:SetPoint("BOTTOMLEFT", vexalarm.frames[frame], "BOTTOMLEFT",
									vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"],
									(vexalarm_f_data[frame]["design"]["position"]["alarm"]["spacing"]*position)-vexalarm_f_data[frame]["design"]["position"]["alarm"]["y"])

	else
		fontstring:SetPoint("TOPLEFT", vexalarm.frames[frame], "TOPLEFT",
									vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"],
									(-vexalarm_f_data[frame]["design"]["position"]["alarm"]["spacing"]*position)+vexalarm_f_data[frame]["design"]["position"]["alarm"]["y"])
	end		
			
			
	fontstring:SetText(msg)
	fontstring:SetTextColor(vexalarm_f_data[frame]["design"]["text"]["color"][statusstring]["r"],
						vexalarm_f_data[frame]["design"]["text"]["color"][statusstring]["g"],
						vexalarm_f_data[frame]["design"]["text"]["color"][statusstring]["b"],
						vexalarm_f_data[frame]["design"]["text"]["color"][statusstring]["a"])
	fontstring:SetFont(vexalarm.LSM:Fetch("font", vexalarm_f_data[frame]["design"]["text"]["font"]),
				vexalarm_f_data[frame]["design"]["text"]["size"],
				vexalarm_f_data[frame]["design"]["text"]["outline"])	
	fontstring:SetJustifyH(vexalarm_f_data[frame]["design"]["text"]["align"])
	fontstring:SetWidth(vexalarm_f_data[frame]["design"]["size"]["width"]-vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"])
	local newmsgframe_aniGRP = newframe:CreateAnimationGroup("newmsgframe_aniGRP")
	newmsgframe_aniGRP:SetLooping("NONE")
	newmsgframe_ani = newmsgframe_aniGRP:CreateAnimation("Alpha")
	newmsgframe_ani:SetStartDelay(vexalarm_f_data[frame]["timedata"]["show"])
	newmsgframe_ani:SetOrder(1)
	newmsgframe_ani:SetSmoothing("IN")
		newmsgframe_ani:SetEndDelay(0)
		newmsgframe_aniGRP:SetScript("OnFinished",
			function (self)
				local parentframe = self:GetParent()
				parentframe:Hide()
			end)
		
	if status and vexalarm_spells_defaults[tostring(spellid)][7]~=nil then
		vexalarm_totem_new(alarmtype, spell, spellid, caster, target, frame)
	end
	
	--adding fade-out-effect
	if vexalarm_f_data[frame]["timedata"]["allowvanish"] then
		newmsgframe_ani:SetDuration(vexalarm_f_data[frame]["timedata"]["vanish"])
		newmsgframe_ani:SetChange(-1)
	else
		newmsgframe_ani:SetDuration(0)
		newmsgframe_ani:SetChange(1)
	end
	newmsgframe_aniGRP:Play()
	
	vexalarm.proclaims[frame][#vexalarm.proclaims[frame]+1] = {time(), {newframe, fontstring, newmsgframe_aniGRP}, position}
end

function vexalarm_generate_singlealarm(alarmtype, spell, spellid, caster, target, status, frame)
	--load custom msg
	local customalarm = ""
	local statusstring = "inactive"
	if status then statusstring = "active" end
	if 		alarmtype == "buff" 		then customalarm = vexalarm_data["proclaims"]["msgs"]["buff"][statusstring]
	elseif 	alarmtype == "selfbuff"	  	then customalarm = vexalarm_data["proclaims"]["msgs"]["selfbuff"][statusstring]
	elseif 	alarmtype == "grpbuff"	 	then customalarm = vexalarm_data["proclaims"]["msgs"]["grpbuff"][statusstring]
	elseif 	alarmtype == "instant" 		then customalarm = vexalarm_data["proclaims"]["msgs"]["instant"]
	elseif 	alarmtype == "instantself" 	then customalarm = vexalarm_data["proclaims"]["msgs"]["instantself"]
	end
	
	--load custom status msg
	local statustext=vexalarm_data["proclaims"]["msgs"]["status"][statusstring]
	
	-- change [spell]
	if spell ~= nil then
		customalarm = string.gsub(customalarm, "%[spell%]", spell)
		customalarm = string.gsub(customalarm, "%[spell_sc%]", vexalarm_colorize_specific(spell, 3, frame))
		customalarm = string.gsub(customalarm, "%[spell_cc%]", vexalarm_colorize_class(spell, spellid, "spell"))
	end
	
	-- change [caster]
	if caster ~= nil then
		customalarm = string.gsub(customalarm, "%[caster%]", caster)
		customalarm = string.gsub(customalarm, "%[caster_sc%]", vexalarm_colorize_specific(caster, 1, frame))
		customalarm = string.gsub(customalarm, "%[caster_cc%]", vexalarm_colorize_class(caster, spellid, "caster"))
	end
	
	-- change [target]
	if target ~= nil then
		customalarm = string.gsub(customalarm, "%[target%]", target)
		customalarm = string.gsub(customalarm, "%[target_sc%]", vexalarm_colorize_specific(target, 2, frame))
		customalarm = string.gsub(customalarm, "%[target_cc%]", vexalarm_colorize_class(target, spellid, "target"))
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "%[status%]", statustext)
		customalarm = string.gsub(customalarm, "%[status_sc%]", vexalarm_colorize_status(statustext, status, frame))
		customalarm = string.gsub(customalarm, "%[status_cc%]", vexalarm_colorize_status(statustext, status, frame))
	end
	return customalarm
end

function vexalarm_checkshow()
	local show = {}
	for key in pairs(vexalarm.frames) do
		if vexalarm_data["enable"] then
			if vexalarm_f_data[key]["show"]["showonlyinfight"] and not(vexalarm.infight) then
				vexalarm.frames[key]:Hide()
			else
				vexalarm.frames[key]:Show()
			end
		else
			vexalarm.frames[key]:Hide()
		end
	end
end

function vexalarm_myspellcheck(caster, frame)
	local returnvalue = true
	
	local check = ""
	if frame == "rw" then
		check = vexalarm_data["rw"]["show"]["myspells"]
	else
		check = vexalarm_f_data[frame]["show"]["myspells"]
	end
	
	if not(check) and caster==select(1, UnitName("player")) then returnvalue = false end	
	return returnvalue
end

function vexalarm_showgrpcheck(caster, frame)
	local returnvalue = true
	
	local check = ""
	if frame == "rw" then
		check = vexalarm_data["rw"]["show"]["showgrponly"]
	else
		check = vexalarm_f_data[frame]["show"]["showgrponly"]
	end
	
	if not(vexalarm_grpcheck(caster)) and check and caster~=select(1, UnitName("player")) then returnvalue = false end
	return returnvalue
end

function vexalarm_grpcheck(caster)
	local returnvalue = false
	returnvalue = UnitInRaid(caster)
	if not(returnvalue) then returnvalue = UnitInParty(caster) end
	return returnvalue
end

function vexalarm_getplayerrole(player)
	local returnvalue = 4
	if player ~= nil then
		local role = UnitGroupRolesAssigned(player)
		if role == "DAMAGER" then
			returnvalue = 3
		elseif role == "HEALER" then
			returnvalue = 2
		elseif role == "TANK" then
			returnvalue = 1
		else
			returnvalue = 4
		end
	end
	return returnvalue
end

function vexalarm_playSound(status, alarmtype, frame)
	if vexalarm_f_data[frame]["sounds"]["allow"] and vexalarm.frames[frame]:IsShown() then 
		if alarmtype == "instant" or alarmtype == "instantself" then 
			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_f_data[frame]["sounds"]["cast"]["file"]), vexalarm_f_data[frame]["sounds"]["cast"]["channel"])
		else
			if status then 	PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_f_data[frame]["sounds"]["active"]["file"]), vexalarm_f_data[frame]["sounds"]["active"]["channel"])
			else 			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_f_data[frame]["sounds"]["inactive"]["file"]), vexalarm_f_data[frame]["sounds"]["inactive"]["channel"]) end
		end
	end
end

function vexalarm_proclaim(alarmtype, spell, spellid,  caster, target, status, frame)
	local msg = vexalarm_generate_singlealarm(alarmtype, spell, spellid, caster, target, status, frame)
	if msg~="" then
		vexalarm_generate_fulltext(alarmtype, spell, spellid, caster, target, status, msg, frame)
		vexalarm_playSound(status, alarmtype, frame)
	end
end