vexalarm = {}
vexalarm.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexalarm.AceConfig = LibStub("AceConfig-3.0", true)
vexalarm.AceConsole= LibStub("AceConsole-3.0", true)
vexalarm.LSM = LibStub("LibSharedMedia-3.0", true)
vexalarm.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)
vexalarm.Locale = LibStub("AceLocale-3.0"):GetLocale("Vex Alarm")

--Start values
vexalarm.infight = false
vexalarm.frames = {}

vexalarm.last_spell_id = {}
vexalarm.last_spell_timestamp = {}
vexalarm.last_spell_event = {}
vexalarm.last_spell_caster = {}
vexalarm.last_spell_id_RW = ""
vexalarm.last_spell_timestamp_RW = 0
vexalarm.last_spell_event_RW = ""
vexalarm.last_spell_caster_RW = ""
vexalarm.proclaims = {}
vexalarm.proclaimPlaces = {}
vexalarm.totemsPlaced = {}
vexalarm.totemsPlaced_RW = {}

vexalarm.testmode = false
vexalarm.wrongspells = {}

vexalarm.incomeMsgs = {}
vexalarm.incomeSpellProfiles = {}
vexalarm.sentMsgs = {}


SLASH_VEXALARM1 = "/vexalarm"
SLASH_VEXALARM2 = "/vexa"
function SlashCmdList.VEXALARM(msg, editbox)
	local command, args = msg:match("^(%S*)%s*(.-)$")
	
	if command == "" or command == "option" or command == "options" or command == "config" or command == "configs" then
		InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel)
	elseif command == "profile" then
		vexalarm_spellprofile_load(args, true)
	elseif command == "defaults" then
		print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["print defaults loaded"])
		vexalarm_loaddefaults(true)
	elseif command == "test" then
		vexdebugs.print(vexalarm_checkRaidWarningChannel(),'vexalarm_checkRaidWarningChannel')
	elseif command == "enable" then
		vexalarm_data["enable"] = not(vexalarm_data["enable"])
		if vexalarm_data["enable"] then
			print("|CFFFF7D0AVex Alarm|r - Addon "..vexalarm.Locale["print addon enabled"])
		else
			print("|CFFFF7D0AVex Alarm|r - Addon "..vexalarm.Locale["print addon disabled"])
		end
		vexalarm_initialize(true)
	elseif command == "wrongspells" then
		vexdebugs.print(vexalarm.wrongspells, "vexalarm.wrongspells")
	elseif command == "rw" then
		vexalarm_data["rw"]["activate"] = not(vexalarm_data["rw"]["activate"])
		if vexalarm_data["rw"]["activate"] then
			print("|CFFFF7D0AVex Alarm|r - Raid Warnings "..vexalarm.Locale["print addon enabled"])
		else
			print("|CFFFF7D0AVex Alarm|r - Raid Warnings "..vexalarm.Locale["print addon disabled"])
		end
		vexalarm_initialize(true)
	else
		print ("|CFFFF7D0AVex Alarm|r "..vexalarm.Locale["print cmd not found"])
		print ("|CFFFF7D0A/vexalarm|r "..vexalarm.Locale["print slashs useable"])
		print ("|CFFFF7D0A/vexalarm|r option/options/config/configs - "..vexalarm.Locale["print slashs options"])
		print ("|CFFFF7D0A/vexalarm|r defaults - "..vexalarm.Locale["print slashs defaults"])
		print ("|CFFFF7D0A/vexalarm|r profile "..vexalarm.Locale["print slashs profile"])
		print ("|CFFFF7D0A/vexalarm|r enable - "..vexalarm.Locale["print slashs enable"])
		print ("|CFFFF7D0A/vexalarm|r rw - "..vexalarm.Locale["print slashs rw"])
	end
end

function vexalarm_OnEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexalarm_initialize()
		-- print("|CFFFF7D0AVex Alarm|r loaded")
	elseif event == "PLAYER_REGEN_DISABLED" then
		vexalarm.infight = true
		vexalarm_checkshow()
	elseif event == "PLAYER_REGEN_ENABLED" then
		vexalarm.infight = false
		vexalarm_checkshow()
	elseif event == "CHAT_MSG_ADDON" then
		if select(4, ...) ~= select(1, UnitName("player")) then
			local prefix = select(1, ...)
			local msg = select(2, ...)
			local sender = select(4, ...)
			if prefix == "VEXALARM_SP" then
				vexalarm_ReceiveSpellProfile(msg, sender)
			elseif prefix == "VEXALARM_SP_RE" then
				vexalarm_ReceiveSpellProfileRE(msg, sender)
			end
		end
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if vexalarm_data["enable"] then
			local eventchar  = select(2, ...)
			local legal_eventchars = {
				"SPELL_AURA_APPLIED",
				"SPELL_CAST_SUCCESS",
				"SPELL_AURA_REMOVED",
				"SPELL_SUMMON",
				"SPELL_RESURRECT",
				}
				
			local accept_event = false
			for i,v in ipairs(legal_eventchars) do
				if eventchar == v then
					accept_event = true
				end
			end
			
			if accept_event then
				local caster = select(5, ...)
				local spellid = select(12, ...)
				local spellname = select(13, ...)
				local target = select(9, ...)
				local status = eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT"
				for key in pairs(vexalarm.frames) do
					vexalarm_check_fulltext(key)
					if vexalarm_myspellcheck(caster, key) and vexalarm_showgrpcheck(caster, key) then
						local alarmtype = vexalarm_spellcheck(spellid, caster, eventchar, key)
						if(alarmtype ~="" and alarmtype ~="dejavue") then
							vexalarm_proclaim(alarmtype, spellname, spellid, caster, target, status, key)				
						end
					end
				end
				
				if vexalarm_myspellcheck(caster, "rw") and vexalarm_showgrpcheck(caster, "rw") and vexalarm_data["rw"]["activate"] then
					alarmtype = vexalarm_spellcheck(spellid, caster, eventchar, "rw")
					if(alarmtype ~="" and alarmtype ~="dejavue") then
						vexalarm_proclaim_RW(alarmtype, spellname, spellid, caster, target, status)				
					end
				end
			elseif eventchar == "UNIT_DESTROYED" then
				vexalarm_totem_clean()
				
				local spellname = select(9, ...)
				for key in pairs(vexalarm.frames) do
					if vexalarm_totem_find(key, spellname) then
						local alarmtype = vexalarm.totemsPlaced[key][spellname][2][1]
						local spellid = vexalarm.totemsPlaced[key][spellname][2][2]
						local caster = vexalarm.totemsPlaced[key][spellname][2][3]
						local target = vexalarm.totemsPlaced[key][spellname][2][4]
						
						vexalarm_proclaim(alarmtype, spellname, spellid, caster, target, false, key)
						vexalarm_totem_delete(key, spellname)
					end
				end
				
				if vexalarm_totem_find_RW(spellname) then
					local alarmtype = vexalarm.totemsPlaced_RW[spellname][2][1]
					local spellid = vexalarm.totemsPlaced_RW[spellname][2][2]
					local caster = vexalarm.totemsPlaced_RW[spellname][2][3]
					local target = vexalarm.totemsPlaced_RW[spellname][2][4]
					vexalarm_proclaim_RW(alarmtype, spellname, spellid, caster, target, false)
					vexalarm_totem_delete_RW(spellname)
				end
			end
		end
	end
end

function vexalarm_initialize(reload)
	RegisterAddonMessagePrefix("VEXALARM_SP")
	RegisterAddonMessagePrefix("VEXALARM_SP_RE")
	
	vexalarm_loaddefaults(false)
	vexalarm_buildFrames()
	vexalarm_checkshow()
	vexalarm_optionpanel_OnLoad(reload)
	
	vexalarm.inRaid = UnitInRaid("player")
	
	if not(reload) then 
		for i=1,40 do
			if i<10 then	k = "0"..i
			else			k = ""..i end
			vexalarm.LSM:Register("sound", k, "Interface\\AddOns\\vexalarm\\sounds\\button_"..i..".ogg")
		end
		vexalarm.LSM:Register("border", "Solid", "Interface\\Buttons\\WHITE8X8")
		vexalarm.LSM:Register("font", "Emblem", "Interface\\AddOns\\vexalarm\\fonts\\EMBLEM.tff")
	end
end