-- ######### GENERAL #######
function vexalarm_dec2hex(r,g,b)
	if r == nil then r = 0 end
	if g == nil then g = 0 end
	if b == nil then b = 0 end
    return string.format("%02x%02x%02x", r*250, g*250, b*250)
end

function vexalarm_checkName(val)
	local returnvalue = false
	
	local val_edited = val
	val_edited = string.gsub(val_edited, "%a", "")
	val_edited = string.gsub(val_edited, "%d", "")
	val_edited = string.gsub(val_edited, " ", "")
	
	if val_edited == "" then
		returnvalue = true
	end
	
	if val == "" or string.lower(val) == "none" then
		returnvalue = false
	end
	
	return returnvalue
end

function vexalarm_validateInput(val)
	if vexalarm_checkName(val) then
		return true
	else
		return "ERROR - "..val.." is not a valid name"
	end
end

function vexalarm_getDisabled(list, val)
	if list[val] == nil then
		return true
	else
		return false
	end
end

-- ######### FRAMES ####### 

function vexalarm_frames_setSP(frame, sp)
	vexalarm_f_data[frame]["spelldata"]["spellprofile"] = sp
end

function vexalarm_frames_getSP(frame)
	return vexalarm_f_data[frame]["spelldata"]["spellprofile"]
end

function vexalarm_frames_setSPusage(frame, val)
	vexalarm_f_data[frame]["spelldata"]["useprofile"] = val
end

function vexalarm_frames_getSPusage(frame)
	return vexalarm_f_data[frame]["spelldata"]["useprofile"]
end

function vexalarm_frames_setCurrent()
	if vexalarm_frames_getlist(true) == 1 then
		for key in pairs(vexalarm.frames) do
			vexalarm_framepanel_currentframe=key
		end
	end
end

function vexalarm_frames_getlist(returntimer)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm.frames) do
		returnvalue[key]=key
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue["NONE"] = "No frame created"
	end
	
	if returntimer then
		return timer
	else
		return returnvalue
	end
end

function vexalarm_frames_getlistGet()
	if vexalarm_frames_getlist()["NONE"] == nil then
		return vexalarm_framepanel_currentframe
	else
		return "NONE"
	end
end

function vexalarm_frames_getlistGetClone()
	if vexalarm_frames_getlist()["NONE"] == nil then
		return vexalarm_framepanel_cloneframe
	else
		return "NONE"
	end
end

function vexalarm_frame_add()
	local key = vexalarm_framepanel_new
	
	if vexalarm_checkName(key) then
		vexalarm_f_data[key] = vexalarm_CopyTable(vexalarm_frame_defaults["Mainframe"])
		vexalarm_framepanel_new = ""
	end
	vexalarm_frames_setCurrent()
end

function vexalarm_frame_clone()
	local key = vexalarm_framepanel_new
	local clone = vexalarm_framepanel_cloneframe
	
	if vexalarm_checkName(key) and vexalarm_f_data[clone] ~= nil then
		vexalarm_f_data[key] = vexalarm_CopyTable(vexalarm_f_data[clone])
		vexalarm_framepanel_new = ""
	end
end


function vexalarm_frame_change()
	local key = vexalarm_framepanel_currentframe
	local name = vexalarm_framepanel_change
	
	if vexalarm_checkName(name) and vexalarm_f_data[key]~=nil then
		vexalarm_f_data[name] = vexalarm_CopyTable(vexalarm_f_data[key])
		vexalarm_f_data[key] = nil
		vexalarm_framepanel_change = name
		vexalarm_framepanel_currentframe = name
	end
end

function vexalarm_frame_delete()
	local key = vexalarm_framepanel_currentframe	
	if vexalarm_checkName(key) and vexalarm_f_data[key]~=nil then
		vexalarm_f_data[key] = nil
		vexalarm_framepanel_currentframe = ""
		vexalarm_framepanel_change = ""
	end
	vexalarm_frames_setCurrent()
end

function vexalarm_frame_textreturn(data, arg)
	if vexalarm_f_data[vexalarm_framepanel_currentframe] == nil then
		if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
			return 0
		else
			return nil
		end
	else
		local framedata = vexalarm_f_data[vexalarm_framepanel_currentframe]
		if 		data == "font" 				then return framedata["design"]["text"]["font"]
		elseif 	data == "size"				then return framedata["design"]["text"]["size"]
		elseif 	data == "align"				then return framedata["design"]["text"]["align"]
		elseif 	data == "outline"			then return framedata["design"]["text"]["outline"]
		elseif 	data == "alarmx"			then return framedata["design"]["position"]["alarm"]["x"]
		elseif 	data == "alarmy"			then return framedata["design"]["position"]["alarm"]["y"]
		elseif 	data == "alarms"			then return framedata["design"]["position"]["alarm"]["spacing"]
		elseif 	data == "maxevents"			then return framedata["design"]["maxevents"]
		elseif 	data == "scrolldown"		then return framedata["design"]["scrolldown"]
		
		
		elseif 	data == "status_sca"		then return framedata["design"]["text"]["color"]["active"][arg]
		elseif 	data == "status_sci"		then return framedata["design"]["text"]["color"]["inactive"][arg]
		
		elseif 	data == "colorg"			then return framedata["colors"]["active"][arg]
		elseif 	data == "colorf"			then return framedata["colors"]["inactive"][arg]
		elseif 	data == "caster_sc"			then return framedata["colors"]["caster_sc"][arg]
		elseif 	data == "target_sc"			then return framedata["colors"]["target_sc"][arg]
		elseif 	data == "spell_sc"			then return framedata["colors"]["spell_sc"][arg]
		
		
		elseif 	data == "allowvanish"		then return framedata["timedata"]["allowvanish"]
		elseif 	data == "tdshow"			then return framedata["timedata"]["show"]
		elseif 	data == "tdvanish"			then return framedata["timedata"]["vanish"]
		elseif 	data == "allowscrolling"	then return not(framedata["design"]["allowscrolling"])
		else 
			if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
				return 0
			else
				return nil
			end
		end
	end
end

function vexalarm_frame_datareturn(data, arg)
	if vexalarm_f_data[vexalarm_framepanel_currentframe] == nil then
		if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
			return 0
		else
			return nil
		end
	else
		local framedata = vexalarm_f_data[vexalarm_framepanel_currentframe]
		if 		data == "width" 	then return framedata["design"]["size"]["width"]
		elseif 	data == "height"	then return framedata["design"]["size"]["height"]
		elseif 	data == "x"			then return framedata["design"]["position"]["bg"]["x"]
		elseif 	data == "y"			then return framedata["design"]["position"]["bg"]["y"]
		elseif 	data == "anchor1"	then return framedata["design"]["position"]["bg"]["anchor"]
		elseif 	data == "anchor2"	then return framedata["design"]["position"]["bg"]["frameanchor"]
		elseif 	data == "bgtexture"	then return framedata["design"]["bg"]["texture"]
		elseif 	data == "bgcolor"	then return framedata["design"]["bg"]["color"][arg]
		elseif 	data == "bordert"	then return framedata["design"]["border"]["texture"]
		elseif 	data == "borders"	then return framedata["design"]["border"]["size"]
		elseif 	data == "borderc"	then return framedata["design"]["border"]["color"][arg]
		elseif 	data == "height"	then return framedata["design"]["size"]["height"]
		else 
			if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
				return 0
			else
				return nil
			end
		end
	end
end

function vexalarm_frame_soundreturn(data)
	if vexalarm_f_data[vexalarm_framepanel_currentframe] == nil then
		return nil
	else
		local framedata = vexalarm_f_data[vexalarm_framepanel_currentframe]
		if 		data == "allow" 	then return framedata["sounds"]["allow"] 
		elseif 	data == "file1"		then return framedata["sounds"]["active"]["file"]
		elseif 	data == "file2"		then return framedata["sounds"]["inactive"]["file"]
		elseif 	data == "file3"		then return framedata["sounds"]["cast"]["file"]
		elseif 	data == "channel1"	then return framedata["sounds"]["active"]["channel"]
		elseif 	data == "channel2"	then return framedata["sounds"]["inactive"]["channel"]
		elseif 	data == "channel3"	then return framedata["sounds"]["cast"]["channel"]
		else 
			return nil
		end
	end
end

function vexalarm_frame_showreturn(data)
	if vexalarm_f_data[vexalarm_framepanel_currentframe] == nil then
		return nil
	else
		local framedata = vexalarm_f_data[vexalarm_framepanel_currentframe]
		if 		data == "showonlyinfight" 	then return framedata["show"]["showonlyinfight"] 
		elseif 	data == "showgrponly"		then return framedata["show"]["showgrponly"]
		elseif 	data == "myspells"			then return framedata["show"]["myspells"]
		else 
			return nil
		end
	end
end

-- ######### PROFILES #######
function vexalarm_profile_add()
	local key = vexalarm_profiles_profile_new
	if vexalarm_checkName(key) then
		if vexalarm_p[key] == nil then vexalarm_p[key] = {} end
		
		-- DATA
		if vexalarm_p[key]["data"] == nil then vexalarm_p[key]["data"] = {} end
		vexalarm_p[key]["data"] = vexalarm_CopyTable(vexalarm_data)
		
		-- F DATA
		if vexalarm_p[key]["f_data"] == nil then vexalarm_p[key]["f_data"] = {} end
		vexalarm_p[key]["f_data"] = vexalarm_CopyTable(vexalarm_f_data)
		
		-- SP
		if vexalarm_p[key]["sp"] == nil then vexalarm_p[key]["sp"] = {} end
		vexalarm_p[key]["sp"] = vexalarm_CopyTable(vexalarm_sp)
		
		-- S
		if vexalarm_p[key]["s"] == nil then vexalarm_p[key]["s"] = {} end
		vexalarm_p[key]["s"] = vexalarm_CopyTable(vexalarm_s)
		
		vexalarm_profiles_profile_new = ""
	end
end


function vexalarm_profile_getlist()
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_p) do
		returnvalue[key]=key
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue["NONE"] = "No saved profile found"
	end
	
	return returnvalue
end

function vexalarm_profile_getlistGet()
	if vexalarm_profile_getlist()["NONE"] == nil then
		return vexalarm_profiles_profile
	else
		return "NONE"
	end
end

function vexalarm_profile_delete()
	local key = vexalarm_profiles_profile
	
	if vexalarm_checkName(key) then
		vexalarm_p[key] = nil
		vexalarm_profiles_profile_change = ""
		vexalarm_profiles_profile = ""
	end
end

function vexalarm_ChangeProfile()
	local key = vexalarm_profiles_profile
	local name = vexalarm_profiles_profile_change
	
	if vexalarm_checkName(name) and vexalarm_p[key]~=nil then
		vexalarm_p[name] = vexalarm_CopyTable(vexalarm_p[key])
		vexalarm_p[key] = nil
		vexalarm_profiles_profile_change = name
		vexalarm_profiles_profile = name
	end
end

function vexalarm_profile_load(fragment)
	local key = vexalarm_profiles_profile
	if vexalarm_checkName(key) then
		if vexalarm_p[key] ~= nil then 
			if fragment == "all" then
				vexalarm_profile_load("data")
				vexalarm_profile_load("f_data")
				vexalarm_profile_load("sp")
				vexalarm_profile_load("s")
			elseif fragment == "data" then
				vexalarm_data = vexalarm_CopyTable(vexalarm_p[key]["data"])
			elseif fragment == "f_data" then
				vexalarm_f_data = vexalarm_CopyTable(vexalarm_p[key]["f_data"])
			elseif fragment == "sp" then
				for k,v in pairs (vexalarm_CopyTable(vexalarm_p[key]["sp"])) do
					vexalarm_sp[k] = vexalarm_CopyTable(v)
				end
			elseif fragment == "s" then
				vexalarm_s = vexalarm_CopyTable(vexalarm_p[key]["s"])
			end
			vexalarm_initialize(true)
		end
	end
end


-- ######### RW #######
function vexalarm_spellprofile_getlistGet_RW()
	if vexalarm_spellprofile_getlist()["NONE"] == nil then
		return vexalarm_data["rw"]["spelldata"]["spellprofile"]
	else
		return "NONE"
	end
end

-- ######### SPELLPROFILES #######
function vexalarm_spellprofile_getlist()
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_sp) do
		returnvalue[key]=key
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue["NONE"] = "No saved profile found"
	end
	
	return returnvalue
end

function vexalarm_spellprofile_getlistGet()
	if vexalarm_spellprofile_getlist()["NONE"] == nil then
		return vexalarm_spellprofiles_profile
	else
		return "NONE"
	end
end

function vexalarm_spellprofile_add()
	local key = vexalarm_spellprofiles_profile_new
	
	if vexalarm_checkName(key) then
		vexalarm_sp[key] = vexalarm_CopyTable(vexalarm_s)
		vexalarm_spellprofiles_profile_new = ""
	end
end

function vexalarm_ChangeSpellProfile()
	local key = vexalarm_spellprofiles_profile
	local name = vexalarm_spellprofiles_profile_change
	
	if vexalarm_checkName(name) and vexalarm_sp[key]~=nil then
		vexalarm_sp[name] = vexalarm_CopyTable(vexalarm_sp[key])
		vexalarm_sp[key] = nil
		vexalarm_spellprofiles_profile_change = name
		vexalarm_spellprofiles_profile = name
	end
end

function vexalarm_spellprofile_delete()
	local key = vexalarm_spellprofiles_profile
	
	if vexalarm_checkName(key) then
		vexalarm_sp[key] = nil
		vexalarm_spellprofiles_profile = ""
		vexalarm_spellprofiles_profile_change = ""
	end
end

function vexalarm_spellprofile_load(key, slashcmd)
	if key == nil then
		key = vexalarm_spellprofiles_profile
	end
	if vexalarm_checkName(key) then
		if vexalarm_sp[key] == nil then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["spellprofiles profile not found"])
		else
			vexalarm_s = vexalarm_CopyTable(vexalarm_sp[key])
			vexalarm_loaddefaults(false)
			if slashcmd then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["spellprofiles profile loaded 1"].." '"..key.."' "..vexalarm.Locale["spellprofiles profile loaded 2"]) end
		end
	end
end

function vexalarm_GetReceivedSpellProfileList()
	local returnvalue = {}
	for key,val in pairs(vexalarm.incomeSpellProfiles) do
		returnvalue[key] = val["timestamp"].." "..val["name"]
	end
	if #returnvalue == 0 then
		returnvalue["NONE"] = "No received profile found"
	end
	return returnvalue
end

function vexalarm_GetReceivedSpellProfileListGet()
	if vexalarm_GetReceivedSpellProfileList()["NONE"] == nil then
		return vexalarm_spellprofiles_profile
	else
		return "NONE"
	end
end

function vexalarm_GetReceivedSpellProfileByKey(key)
	return vexalarm.incomeSpellProfiles[key]["name"]
end

function vexalarm_SaveReceivedSP()
	local key = vexalarm_spellprofiles_receivedprofile
	local name = vexalarm_spellprofiles_receivedprofile_newname
	if vexalarm_checkName(name) then
		vexalarm_sp[name] = vexalarm_CopyTable(vexalarm.incomeSpellProfiles[key]["data"])
		vexalarm_spellprofiles_receivedprofile_load = ""
		vexalarm_spellprofiles_receivedprofile_name = ""
	end
end